-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.relevantDevice = "transfercase"

local shaft = nil
local name = nil
local hasBuiltPie = false

local function updateGFX(dt)

end

local function toggle8WD()
  if shaft and not shaft.isPhysicallyDisconnected then
    powertrain.toggleDeviceMode(shaft.name)
    local status = "8WD"
    if shaft.mode == "disconnected" then status = "4WD" end
    gui.message("Drive Status: "..status, 10, "powertrain.shaftstatus")
  end
end

local function init(jbeamData)
  name = jbeamData.name
  shaft = powertrain.getDevice(jbeamData.shaftName)

  if not hasBuiltPie then
    if shaft then
      quickAccess.addEntry({ level = '/powertrain/', generator = function(entries)
            local entry = { title = 'Drive Mode', onSelect = function() controller.getController(name).toggle8WD() return {'reload'} end}
            table.insert(entries, entry)
          end})
    end
    quickAccess.addEntry({ level = '/powertrain/', generator = function(entries)
          local entry = { title = 'Diff Mode', onSelect = function() powertrain.toggleDefaultDiffs() return {'reload'} end}
          table.insert(entries, entry)
        end})
    hasBuiltPie = true
  end
end

M.init = init
--M.updateGFX = updateGFX
M.toggle8WD = toggle8WD
M.setInterAxleDiffMode = setInterAxleDiffMode
M.setAxleDiffMode = setAxleDiffMode
M.set8WDMode = set8WDMode

return M